/*	There is no reason to store buttons and dragareas in the 
same place. */

#ifndef IE_TYPES_INCL
#define IE_TYPES_INCL

typedef struct IEButton	{
	BigString name;
	BigString text;
	int x, y, wd, ht;
	BigString efgcolorname, dfgcolorname;
	BigString bgcolor, funcname;
	boolean border, repeatable;
	ButtonStatusType active;
	BtnLabPosType textjust;
	struct IEButton *nextbutton, *prevbutton;
	int tsize;
	ArrowSymType arrow;
	boolean visibleineditor;
	} IEButton;

typedef struct IEDragArea {
	BigString name;
	int x, y, wd, ht;
	BigString col;
	BigString funcname;
	boolean active;
	struct IEDragArea  *nextdragarea, *prevdragarea;
	} IEDragArea;


typedef struct	IEGraphic{
	Graphic gr;
	BigString grcol;
	BigString grshadowcol;
	struct	IEGraphic  *nextgraphic, *prevgraphic;
	} IEGraphic;

	
typedef struct	IEField{
	BigString name;
	int x, y, wd, ht;
	BigString col;
	struct	IEField *nextfield, *prevfield;
	} IEField;


/*	Like buttons, we have to draw our own windows. */

typedef struct	IEWindow{
	boolean visibleineditor;
	BigString name;
	int x, y, wd, ht;
	BigString fgcol, bgcol, bdrcol;
	int bordersize;
	boolean active;
	int bstore_to_use;
	struct	IEWindow *nextwin, *prevwin;
	IEButton *firstbutton, *lastbutton;
	IEDragArea *firstdragarea, *lastdragarea;
	IEGraphic *firstgraphic, *lastgraphic;
	IEField *firstfield, *lastfield;
	} IEWindow;
	
typedef struct IEMenuItem{
	BigString name;
	BigString text;
	int checked;
	MenuItemStatusType active;
	BigString funcname;
	struct IEMenuItem *nextmenuitem;
	}	IEMenuItem;
	
typedef struct IEPopup{
	boolean visibleineditor;
	BigString title;
	int x, y, wd, ht;
	BigString efg, dfg, bg, bcolor;
	BigString function;
	boolean checklist;
	IEMenuItem *itemlisthead, *itemlisttail;
	struct IEPopup *nextpopup, *prevpopup;
	} IEPopup;

typedef struct IEMessage{
	Message msg;
	struct IEMessage *nextmsg;
	} IEMessage;
	
typedef struct IEFunction{
	BigString name;
	int dtime;
	boolean active;
	int mouseoff;
	struct IEFunction *nextfunc;
	} IEFunction;
	
typedef struct	{
  int speedup;            /* Speedup rate factor for pressed buttons */
  BigString colorlist[5][5];  /* A list of user defined colors */
  BigString highlight;        /* Highlight color */
  BigString buttonborder;
  BigString buttonTLcolor;
  BigString buttonBRcolor;
  int diagonals;
  IEMessage *msglisthead, *msglisttail; /* NULL in initial state */
  IEFunction *funclisthead, *funclisttail;/* NULL in initial state */
  BigString redrawfunc;
  IEWindow *winlisthead, *winlisttail;
  IEPopup *popuplisthead, *popuplisttail;
	} IEIconfig;

#define NO_ITEM -1 /* useful for picklist windows */

#endif /* #ifdef IE_TYPES_INCL */
