/***********************************************************************
Mental Maps module global declarations.
***********************************************************************/
#include <stdio.h>
#include "geosim.h"
#include "mmincl.h"

int AlertNumber = 0;

GraphicsFileType GraphFileFmt = BMP_16;

BigString CityFile = "";                /* Name of country city file currently
                                           selected */

BigString Datapath = "/dbase/";         /* path to database */

BigString Infopath = "/info/";          /* path to info and help files */

BigString Home;                         /* Path to the directory that contains
                                           the executable.  Computed from
                                           argv[0]. */

BigString InterfaceFile = "mmap.inf";   /* user interface file */

BigString MapFile = "";                 /* Name of country map file currently
                                           selected */

BigString Outputlogmode = "w";          /* fopen mode for output.log */

BigString Units = "";                   /* Units for statisitics in questions */

BigString VersionFile;                  /* Holds version number string */

BigString UserName = "";                /* User's name */

BigString WarpMapFile = "";             /* Match country map file for warping */

BigString DumpFileName = "";

boolean DumpSuccess = FALSE;

boolean DumpResultsActive = FALSE;      /* TRUE iff results of dumpscreen are
                                           showing in alert window */

boolean DumpWinActive = FALSE;          /* TRUE iff dump window is on screen */

boolean FinalMapActive = FALSE;         /* TRUE iff final map is on screen */

boolean GetName = FALSE;                /* if TRUE, then get user's name */

boolean HelpWinActive = FALSE;          /* TRUE iff help window is on screen */

boolean LoginInProcess = FALSE;         /* TRUE iff user is logging in */

boolean Move_labels = FALSE;

boolean Moving = FALSE;

boolean NotInStepThru = TRUE;           /* True iff cities are not currently
                                           being displayed one-by-one */

boolean Question_item[QUEST_NUM] =
{ FALSE,
  FALSE,
  FALSE,
  FALSE };

boolean Questesc = FALSE;               /* TRUE iff user selected 'Go Back'
                                           button in question window */

boolean QuestionWinActive = FALSE;      /* TRUE iff question window is on
                                           screen */
boolean QuizInProgress = FALSE;         /* TRUE iff quiz in progress */

boolean ResultWinActive = FALSE;        /* TRUE iff result window is on
                                           screen */

boolean SummaryTableWinActive = FALSE;  /* TRUE iff summary table window is on
                                           screen */

boolean ReadDebugInput = FALSE;

boolean Show_results;                   /* Allow popup window of question
                                           results after quiz */

boolean StepThru = FALSE;               /* True iff the cities should be
                                           displayed one-by-one at end of
                                           quiz; set in config.gcf */

boolean Use_bstore = FALSE;

int Citycnt;                            /* Number of cities that have been
                                           asked about in current quiz */

int Curr_city;                          /* Current city being quizzed */

int Curr_country = 0;                   /* Current country being quizzed */

int Default_country = -1;               /* Configure file can set default
                                           country to quiz */

int Levelsback = 0;                     /* Number of levels of undo the user
                                           has gone */

int MovedLabel;

int MovedCity;

int Move_index = 0;


int Num_cities = 5;                     /* Number of cities to ask user about */

int Num_countries = 0;                  /* Number of countries available */

int Prev_quest_status = -1;

int Quest_status;

int ResultWinCity;

int Savemsg = 2;                        /* Number of help message to save for
                                           redisplaying */

City_circle_pixels Citycirclepixels[68]; /* temporary kluge for undoing city
                                           placement */

Countryrec *City;                       /* City list for each country */

Answerrec Answers[MAXASK];              /* Stores user's answers */

Slider Currslide;                       /* Descriptor for currently active
                                           slider bar */

boolean QuitWinActive = FALSE;          /* TRUE iff quit window is on screen */

long *Slideval;                         /* Address to holds the value selected
                                           from a slide bar */

char *StatePCodeTable[][2] =         /* For converting state postal code */
{                                    /* to full state name */
  { "AL", "Alabama" },
  { "AZ", "Arizona" },
  { "AR", "Arkansas" },
  { "CA", "California" },
  { "CO", "Colorado" },
  { "CT", "Connecticut" },
  { "DC", "DC" },
  { "DE", "Delaware" },
  { "FL", "Florida" },
  { "GA", "Georgia" },
  { "ID", "Idaho" },
  { "IL", "Illinois" },
  { "IN", "Indiana" },
  { "IA", "Iowa" },
  { "KS", "Kansas" },
  { "KY", "Kentucky" },
  { "LA", "Louisiana" },
  { "ME", "Maine" },
  { "MD", "Maryland" },
  { "MA", "Massachusetts" },
  { "MI", "Michigan" },
  { "MN", "Minnesota" },
  { "MS", "Mississippi" },
  { "MO", "Missouri" },
  { "MT", "Montana" },
  { "NE", "Nebraska" },
  { "NV", "Nevada" },
  { "NH", "New Hampshire" },
  { "NJ", "New Jersey" },
  { "NM", "New Mexico" },
  { "NY", "New York" },
  { "NC", "North Carolina" },
  { "ND", "North Dakota" },
  { "OH", "Ohio" },
  { "OK", "Oklahoma" },
  { "OR", "Oregon" },
  { "PA", "Pennsylvania" },
  { "RI", "Rhode Island" },
  { "SC", "South Carolina" },
  { "SD", "South Dakota" },
  { "TN", "Tennessee" },
  { "TX", "Texas" },
  { "UT", "Utah" },
  { "VT", "Vermont" },
  { "VA", "Virginia" },
  { "WA", "Washington" },
  { "WV", "West Virginia" },
  { "WI", "Wisconsin" },
  { "WY", "Wyoming" },
  { NULL, NULL }
};
